# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Resource types**

* [`rbac_group`](#rbac_group): A Puppet Enterprise Console RBAC group
* [`rbac_role`](#rbac_role): A Puppet Enterprise Console RBAC role
* [`rbac_user`](#rbac_user): A Puppet Enterprise Console RBAC user

## Resource types

### rbac_group

A Puppet Enterprise Console RBAC group

#### Properties

The following properties are available in the `rbac_group` type.

##### `ensure`

Valid values: present, absent

The basic property that the resource should be in.

Default value: present

##### `roles`

Array of role names for the group

##### `id`

The read-only ID of the group

#### Parameters

The following parameters are available in the `rbac_group` type.

##### `name`

namevar

The name of the group

### rbac_role

A Puppet Enterprise Console RBAC role

#### Properties

The following properties are available in the `rbac_role` type.

##### `ensure`

Valid values: present, absent

The basic property that the resource should be in.

Default value: present

##### `description`

The description of the role

##### `permissions`

Array of permission objects for the role

##### `user_ids`

Array of UUIDs of users (or names) assigned to the role

##### `group_ids`

Array of UUIDs of groups assigned to the role

##### `id`

The read-only ID of the role

#### Parameters

The following parameters are available in the `rbac_role` type.

##### `name`

namevar

The displayed name of the role

### rbac_user

A Puppet Enterprise Console RBAC user

#### Properties

The following properties are available in the `rbac_user` type.

##### `ensure`

Valid values: present, absent

The basic property that the resource should be in.

Default value: present

##### `display_name`

The displayed name of the user

##### `email`

Valid values: /@/

The email address of the user

##### `password`

The plaintext password of the user.

##### `roles`

List of role IDs the user is a member of. The only attribute which can be changed after creation.

Default value: [3]

##### `id`

The read-only ID of the user

##### `remote`

Remote users are managed by an external directory service

##### `superuser`

Whether this user has superuser privileges

##### `last_login`

The last login time for this user

#### Parameters

The following parameters are available in the `rbac_user` type.

##### `name`

Valid values: /^\S+$/

namevar

Login name of the user

